﻿Type=Class
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
Sub Class_Globals
	Private astream As AsyncStreams
	Private mManager As ServerManager
	Private act As Action
End Sub

Public Sub Initialize (socket As Socket, manager As ServerManager)
	Log("New connection")
	act.Initialize
	mManager = manager
	astream.Initialize(socket.InputStream, socket.OutputStream, "astream")
	Dim s As String = $"HTTP/1.1 200 OK
Content-Length: 0

"$
	astream.Write(s.Replace(CRLF, Starter.EOL).GetBytes("ASCII"))
End Sub

Public Sub NewFrame (header() As Byte, data() As Byte)
	astream.Write(header)
	If Not(data=Null) Then 	astream.Write(data)
End Sub

Private Sub AStream_NewData (Buffer() As Byte)
	Dim s As String = BytesToString(Buffer, 0, Buffer.Length, "ASCII")
	For Each line As String In Regex.Split("\n", s)
		If line.StartsWith("POST") Then ' "GET"
			'filter out favicon calls
			If line.Trim <> "POST /action HTTP/1.1" Then
				astream.Close
			End If
		End If
	Next
	
	' should just search buffer for the pair/quad
	Dim i As Int = s.LastIndexOf(Starter.EOL&Starter.EOL)
	If (i>=0) Then
		i = i + Starter.EOL.Length*2
		Dim bytes(Buffer.Length-i) As Byte
			For j = i To Buffer.Length-1
				bytes(j-i)=Buffer(j)
			Next
		
		Dim bytesResp() As Byte = act.HandleBuf(bytes)
		mManager.ResponseHeader(Me, bytesResp)
	End If
	
End Sub

Private Sub AStream_Terminated
	AStream_Error
End Sub

Private Sub AStream_Error
	Log("Error")
	mManager.ClientDisconnected(Me)
End Sub
